// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Fischer
#include "io/Operation.hpp"

#include <ostream>	// for operator<<, stringstream, basi...

#include "Common.hpp"

namespace emper::io {
auto operator<<(std::ostream& os, const Operation& op) -> std::ostream& {
	switch (op) {
		case Operation::SEND:
			os << "send";
			break;
		case Operation::RECV:
			os << "recv";
			break;
		case Operation::CONNECT:
			os << "connect";
			break;
		case Operation::ACCEPT:
			os << "accept";
			break;
		case Operation::OPENAT:
			os << "openat";
			break;
		case Operation::READ:
			os << "read";
			break;
		case Operation::WRITE:
			os << "write";
			break;
		case Operation::WRITEV:
			os << "writev";
			break;
		case Operation::CLOSE:
			os << "close";
			break;
		case Operation::SHUTDOWN:
			os << "shutdown";
			break;
		case Operation::LINK_TIMEOUT:
			os << "linked timeout";
			break;
		case Operation::TIMEOUT:
			os << "timeout";
			break;
		case Operation::CANCEL:
			os << "cancel";
			break;
		case Operation::MADVISE:
			os << "madvise";
			break;
		default:
			DIE_MSG("unknown IO operation:" << (int)op);
	}
	return os;
}
}	 // namespace emper::io
