// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2021-2022 Florian Fischer
#include "lib/env.hpp"

#include <ostream>
#include <string>

#include "Common.hpp"

namespace emper::lib::env {

auto getBoolFromEnv(const std::string& key) -> std::optional<bool> {
	char* envVar = std::getenv(key.c_str());
	if (!envVar) {
		return std::nullopt;
	}

	std::string envStr(envVar);
	if (envStr == "true") {
		return true;
	}

	if (envStr == "false") {
		return false;
	}

	DIE_MSG(key << " has invalid value: " << envStr << " (expected true or false)");
	// Should never be reached.
	return false;
}
}	 // namespace emper::lib::env
