// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2022 Florian Schmaus
#include "WorkStealingQueueLib.hpp"

#include "StealingResult.hpp"
#include "lib/adt/PushBottomResult.hpp"
#include "lib/adt/WsClQueue.hpp"
#include "lib/adt/WsClv3Queue.hpp"
#include "lib/adt/WsClv4Queue.hpp"

namespace emper::extralibs::wsqueue {

constexpr int maxRetries = 0;

namespace cl {
static adt::WsClQueue<int, 16> queue;

auto pushBottom(int value) -> adt::PushBottomResult { return queue.pushBottom(value); }

auto popBottom(int* value) -> bool { return queue.popBottom(value); }

auto popTop(int* value) -> StealingResult { return queue.popTop<maxRetries>(value); }
}	 // namespace cl

namespace cl3 {
static adt::WsClv3Queue<int, 16> queue;

auto pushBottom(int value) -> adt::PushBottomResult { return queue.pushBottom(value); }

auto popBottom(int* value) -> bool { return queue.popBottom(value); }

auto popTop(int* value) -> StealingResult { return queue.popTop<maxRetries>(value); }
}	 // namespace cl3

namespace cl4 {
static adt::WsClv4Queue<int, 16> queue;

auto pushBottom(int value) -> adt::PushBottomResult { return queue.pushBottom(value); }

auto popBottom(int* value) -> bool { return queue.popBottom(value); }

auto popTop(int* value) -> StealingResult { return queue.popTop<maxRetries>(value); }
}	 // namespace cl4

}	 // namespace emper::extralibs::wsqueue
